## TcMenu Example: Take over the display

This example shows the use of a MCP23017 IO expander to take over the display, although could easily be changed to other kinds of IO expanders by redefining the two Io expander variables in the code generator properties (eg PCF8574). Each of these variables must be defined in your sketch file as a type of IoAbstractionRef. If you are unfamiliar with IoAbstraction look at this library documentation for more detail.

I've assumed this will be built on either an Uno or MEGA boards, but should work equally well on any other Arduino board with only minor changes.

To get started you can either build the circuit exactly as below and run without loading the menu designer, alternatively, just load the `takeOverDisplay.emf` file into the designer, select Code / Generate option and change to match your display.

## Files in the example and their purpose:

* `takeOverDisplay.cpp` contains the actual menu item definitions and code needed to start the menu. Do not edit this file, it is regenerated every time you run the designer.
* `takeOverDisplay.h` contains the declarations of the menu items, this allows you to access the menu items in your code.
* `takeOverDisplay.ino` the sketch, this is not fully regenerated every time you run the designer, instead only new callback functions are added if needed.
* `tcMenuLiquidCrystal.cpp` and `.h` are plugins that are managed by the library, these files are put into your code by the designer.
* `takeOverDisplay.emf` is the file where the designer saves the menu structure. It is not used at runtime, only by the designer.